#define addres 0x27
#define lines 4
#define sim 20
#define ENC_TYPE TYPE2
#define S1 2
#define S2 3
#define Key 4
#define maxFps 5

#include <LCD_1602_RUS.h>
#include <GyverEncoder.h>

LCD_1602_RUS lcd(addres, sim, lines);
Encoder enc(S1, S2, Key, ENC_TYPE);

const int verPlatform = 5;
const int verVisual = 5;

byte punt = 1;
int fps = 0;
boolean flag = false;
boolean clear = false;
bool startStopwatch = true;
byte timerPunt = 1;
byte sec = 0;
byte min = 0;
byte hour = 0;
byte addSim = 3;

/*-------Dino-переменые-------*/
byte yDino = 3;
byte xNew = 20;
byte xOld = 0;
byte jumpDinoPos = 0;
boolean jumpDino = false;
boolean oneCact = false;
boolean exitDino = false;
uint64_t fpsInGame;
uint16_t fpsInGameCol;
uint16_t timeTickDino = 100;

#define maxPunt 3
#define timeTick (int) 1000 / maxFps

void setup() {
  //*--------Запуск--------*//
  pinMode(6, OUTPUT);
  digitalWrite(6, HIGH);
  Serial.begin(9600);
  lcd.init();
  lcd.backlight();
  //enc.setTickMode(AUTO);

  //*--------Лого--------*//
  lcd.clear();
  lcd.setCursor((20 - 10) / 2, 1);
  lcd.print("Arduino PC");
  delay(1000);

  //*--------Recovery--------*//
  if (digitalRead(Key) == false) {
    lcd.clear();
    lcd.setCursor((20 - 8) / 2, 1);
    lcd.print("Recovery");
    lcd.setCursor((20 - 14) / 2, 2);
    lcd.print("Держите кнопку");
    uint32_t timeIs = millis();
    boolean isYes = true;
    while (true) {
      if (millis() - timeIs >= 3000) break;
      if (digitalRead(Key) == true) {
        isYes = false;
        break;
      }
    }
    if (isYes == true) {
      lcd.clear();
      while (true) {
        lcd.setCursor(0, 0);
        lcd.print("Ver 1:");
        lcd.print(verPlatform);
        lcd.setCursor(0, 1);
        lcd.print("Ver 2:");
        lcd.print(verVisual);
        delay(1000);
        enc.tick();
        if (enc.isHolded()) {
          lcd.clear();
          lcd.home();
          lcd.print("Rebooting to system!");
          delay(1000);
          asm volatile("JMP 0x00");
          //setup();
          //return;
        }
      }
    }
  }

  lcd.clear();
}

void loop() {
  encoder();
  static uint32_t updDevice;
  static uint32_t frameRate;
  static uint8_t tmpFps;
  if (millis() - updDevice >= timeTick) {
    updDevice = millis();
    tmpFps++;
    if (clear or (flag and punt == 3)) {
      clear = false;
      lcd.clear();
    }
    lcd.setCursor(0, 0);
    lcd.print("   ");
    lcd.setCursor(0, 0);
    lcd.print(fps);
    if (flag) program();
    else menu();
  }
  if (millis() - frameRate >= 1000) {
    frameRate = millis();
    fps = tmpFps;
    tmpFps = 0;
  }
}

void encoder() {
  enc.tick();
  if (enc.isRight()) {
    Serial.println("right");
    if (flag == false) {
      if (punt != maxPunt) {
        punt++;
        lcd.clear();
      }
    } else {
      if (punt == 1 and timerPunt == 1) {
        if (addSim == 3) {
          if (sec == 59 and min == 59 and hour == 99) return;
          sec++;
          if (sec == 60) {
            min++;
            sec = 0;
            if (min == 60) {
              hour++;
              min = 0;
            }
          }
        } else if (addSim == 2) {
          if (min == 59 and hour == 99) return;
          min++;
          if (min == 60) {
            hour++;
            min = 0;
          }
        } else if (addSim == 1) {
          if (hour == 99) return;
          if (hour <= 98) {
            hour++;
          }
        }
      }
    }
  }
  if (enc.isLeft()) {
    Serial.println("left");
    if (flag == false) {
      if (punt != 1) {
        punt--;
        lcd.clear();
      }
    }
    if (flag == true) {
      if (punt == 1 and timerPunt == 1) {
        if (addSim == 3) {
          if (sec >= 1) {
            sec--;
          } else if (sec == 0 and min >= 1) {
            sec = 59;
            min--;
          } else if (sec == 0 and min == 0 and hour >= 1) {
            hour--;
            min = 59;
            sec = 59;
          }
        } else if (addSim == 2) {
          if (min >= 1) {
            min--;
          } else if (min == 0 and hour >= 1) {
            hour--;
            min = 59;
          }
        } else if (addSim == 1) {
          if (hour >= 1) {
            hour--;
          }
        }
      }
    }
  }
  if (enc.isHolded()) {
    if (punt == 3 and flag) {
      exitDino = true;
      return;
    }
    if (flag) {
      flag = false;
      clear = true;
      if (punt == 3 and flag) exitDino = true;
      if (punt == 1 or punt == 2) {
        sec = 0;
        min = 0;
        hour = 0;
        addSim = 3;
        timerPunt = 1;
        startStopwatch = true;
      }
    }
  }
  if (enc.isClick()) {
    if (!flag) {
      flag = true;
      clear = true;
      return;
    }
    if (flag) {
      if (punt == 1 and timerPunt == 1) {
        timerPunt++;
        clear = true;
      }
      if (punt == 3) {
        jumpDino = true;
      }
    }
  }
  if (enc.isRightH()) {
    addSim++;
    if (addSim == 4) addSim = 1;
    clear = true;
  }
  if (enc.isLeftH()) {
    addSim--;
    if (addSim == 0) addSim = 3;
    clear = true;
  }
}

void menu() {
  switch (punt) {
    case 1:
      lcd.setCursor((20 - 6) / 2, 1);
      lcd.print("Таймер");
      break;

    case 2:
      lcd.setCursor((20 - 10) / 2, 1);
      lcd.print("Секундомер");
      break;

    case 3:
      lcd.setCursor((20 - 4) / 2, 1);
      lcd.print("Dino");
      break;
  }

  if (punt == 1) {
    lcd.setCursor(14, 3);
    lcd.print("Next->");
  } else if (punt != 1 and punt != maxPunt) {
    lcd.setCursor(0, 3);
    lcd.print("<-Back");
    lcd.setCursor(14, 3);
    lcd.print("Next->");
  } else if (punt == maxPunt) {
    lcd.setCursor(0, 3);
    lcd.print("<-Back");
  }
}

void program() {
  switch (punt) {
    case 1:
      timer();
      break;
    case 2:
      stopwatch();
      break;
    case 3:
      dino();
      break;
  }
}

void timer() {
  switch (timerPunt) {
    case 1:
      lcd.setCursor((20 - 6) / 2, 0);
      lcd.print("Таймер");
      lcd.setCursor((20 - 8) / 2, 2);
      if (hour < 10) {
        lcd.print('0');
        lcd.print((int) hour);
      } else {
        lcd.print((int) hour);
      }
      lcd.print(':');
      if (min < 10) {
        lcd.print('0');
        lcd.print((int) min);
      } else {
        lcd.print((int) min);
      }
      lcd.print(':');
      if (sec < 10) {
        lcd.print('0');
        lcd.print((int) sec);
      } else {
        lcd.print((int) sec);
      }

      switch (addSim) {
        case 1:
          lcd.setCursor((20 - 8) / 2, 3);
          lcd.print("^^");
          break;
        case 2:
          lcd.setCursor((20 - 8) / 2 + 3, 3);
          lcd.print("^^");
          break;
        case 3:
          lcd.setCursor((20 - 8) / 2 + 6, 3);
          lcd.print("^^");
          break;
      }
      break;
    case 2:
      static uint64_t tmrTimerAdding = millis();

      lcd.setCursor((20 - 6) / 2, 0);
      lcd.print("Таймер");
      lcd.setCursor((20 - 8) / 2, 2);
      if (hour < 10) {
        lcd.print('0');
        lcd.print((int) hour);
      } else {
        lcd.print((int) hour);
      }
      lcd.print(':');
      if (min < 10) {
        lcd.print('0');
        lcd.print((int) min);
      } else {
        lcd.print((int) min);
      }
      lcd.print(':');
      if (sec < 10) {
        lcd.print('0');
        lcd.print((int) sec);
      } else {
        lcd.print((int) sec);
      }
      lcd.setCursor((20 - 4) / 2, 3);
      lcd.print("Идёт");

      if (millis() - tmrTimerAdding >= 1000) {
        tmrTimerAdding = millis();
        if (sec >= 1) {
          sec--;
        } else if (sec == 0 and min >= 1) {
          sec = 59;
          min--;
        } else if (sec == 0 and min == 0 and hour >= 1) {
          hour--;
          min = 59;
          sec = 59;
        }
        if (sec == 0 and min == 0 and hour == 0) {
          timerPunt = 3;
          clear = true;
        }
      }
      break;
    case 3:
      lcd.setCursor((20 - 6) / 2, 0);
      lcd.print("Таймер");
      lcd.setCursor((20 - 11) / 2, 2);
      lcd.print("Время вышло");
  }
}

void stopwatch() {
  static uint64_t stopwatchAdding = millis();

  lcd.setCursor((20 - 10) / 2, 0);
  lcd.print("Секундомер");
  lcd.setCursor((20 - 8) / 2, 2);
  if (hour < 10) {
    lcd.print('0');
    lcd.print((int) hour);
  } else {
    lcd.print((int) hour);
  }
  lcd.print(':');
  if (min < 10) {
    lcd.print('0');
    lcd.print((int) min);
  } else {
    lcd.print((int) min);
  }
  lcd.print(':');
  if (sec < 10) {
    lcd.print('0');
    lcd.print((int) sec);
  } else {
    lcd.print((int) sec);
  }

  if (millis() - stopwatchAdding >= 1000) {
    stopwatchAdding = millis();

    if (startStopwatch == true) {
      startStopwatch = false;
      return;
    }

    if (sec == 59 and min == 59 and hour == 99) return;
    sec++;
    if (sec == 60) {
      min++;
      sec = 0;
      if (min == 60) {
        hour++;
        min = 0;
      }
    }
  }
}

void dino() {
  static uint32_t timerJump = 0;
  static int counter = 0;
  static uint16_t oldFps = 0;
  static uint16_t counterInTick = 0;
  if (xNew < 16) {
    jumpDino = true;
  }
  lcd.setCursor(0, 1);
  lcd.print(counter);
  int tmp = yDino;
  tmp = tmp - 1;
  lcd.setCursor(10, tmp);
  lcd.print(' ');
  lcd.setCursor(10, yDino);
  lcd.print('#');
  tmp = xNew;
  tmp = tmp - 1;
  lcd.setCursor(tmp, 3);
  lcd.print(' ');
  lcd.setCursor(xNew, 3);
  lcd.print('*');
  if (oneCact) {
    tmp = xOld;
    tmp = tmp - 1;
    lcd.setCursor(tmp, 3);
    lcd.print(' ');
    lcd.setCursor(xOld, 3);
    lcd.print('*');
  }
  if (millis() - timerJump >= timeTickDino) {
    timerJump = millis();
    if (oldFps != fps) {
      fpsInGame += fps;
      fpsInGameCol++;
      oldFps = fps;
    }
    if (xNew == 10 and yDino != 3) {
      xOld = xNew;
      xNew = 20;
      counter++;
      counterInTick++;
      if (counterInTick == 10 ) {
        counterInTick = 0;
        if (timeTickDino != 10)timeTickDino -= 10;
      }
      if (!oneCact) oneCact = true;
    } else if (xNew == 10 and yDino == 3) {
      exitDino = true;
    }
    if (exitDino) {
      xNew = 20;
      xOld = 0;
      oneCact = false;
      int fpsSr = (fpsInGame / fpsInGameCol);
      lcd.clear();
      lcd.setCursor(4, 0);
      lcd.print("Счёт: ");
      lcd.print(counter);
      lcd.setCursor(4, 2);
      lcd.print("FPS: ");
      lcd.print(fpsSr);
      delay(2000);
      counter = 0;
      fpsInGame = 0;
      fpsInGameCol = 0;
      clear = true;
      flag = false;
      exitDino = false;
    }
    xNew--;
    if (xOld != 0) xOld--;
    if (jumpDino) {
      jumpDinoPos++;
      if (jumpDinoPos < 4) {
        yDino--;
      } else if (jumpDinoPos > 3 and jumpDinoPos < 7) {
        yDino++;
      }
      if (jumpDinoPos == 6) {
        jumpDino = false;
        jumpDinoPos = 0;
      }
    }
  }
}
